(function(){
// Set up a collection to contain player information. On the server,
// it is backed by a MongoDB collection named "Messages".

Messages = new Meteor.Collection("messages");
Typers = new Meteor.Collection("typers");
Roomers = new Meteor.Collection("roomers");
Rooms = new Meteor.Collection("rooms");
function getEmail(user){
  return user.emails[0].address;
}

function processText(text){
    var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
    text = text.replace(exp,"<a href='$1' target='blank'>$1</a>"); 
    return text.trim();
}

function gravatar_hash(email){
  return hex_md5(email.trim().toLowerCase());
}

if (Meteor.isClient) {
  var toScroll = true;
  var firstRun = true;
  var startingtime;
  var focused = true;
  var played = false;
  var stored_count = 0;
  var scrollme = 0;
  var playfix = false;
  Meteor.methods({

   roomersUpdate: function(room){
	   if(Meteor.user()){
		  roomers_count = Roomers.find({userid: Meteor.user()._id, room: room}).count();
		  if(roomers_count > 1){
          Roomers.remove({room: room, userid: Meteor.user()._id});
          Roomers.insert({userid: Meteor.user()._id, name: Meteor.user().emails[0].address, time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: room});
        }
        else if(roomers_count == 1){
          Roomers.update({room: room}, {$set: {time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now"}});
        }
        else if(roomers_count == 0){
           Roomers.insert({userid: Meteor.user()._id, name: Meteor.user().emails[0].address, time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: room});
        }
      }
      return roomers_count;
    }
  });

  function getCurrentTime(){
    return getServerTime();
  }

  function getHumanTime(){
    return new Date(getCurrentTime()).toISOString();
  }

  function roomersUpdate(room){
    Meteor.call("roomersUpdate",room, function(err, data) {});
  }

  function setServerTime() {
    //get server time (it's in milliseconds)
    Meteor.call("getServerTime", function (error, serverMS) {
      //get client time in milliseconds
      localMS = new Date().getTime();
      //difference between server and client
      var serverOffset = serverMS - localMS;
      //store difference in the session
      console.log('Client-Server Time Offset: ' + serverOffset);
      Session.set('serverTimeOffset', serverOffset);
    });
  }

  function getServerTime() {
    return (new Date()).getTime() + Session.get('serverTimeOffset',0);
  }

  Meteor.startup(function () {
    Meteor.call("LC_APP_NAME", function (error, result) {
      Session.set("LC_APP_NAME",result);
    });
    Meteor.call("LC_APP_EXTRA", function (error, result) {
      Session.set("LC_APP_EXTRA",result);
    });
    Meteor.call("LC_APP_VERSION", function (error, result) {
      Session.set("LC_APP_VERSION",result);
    });
    Meteor.subscribe("basicInfo","#main");
    Meteor.subscribe("messages","#main");
    Meteor.subscribe("typers","#main");
    Meteor.subscribe("roomers","#main");
    if(Meteor.user()){
      roomersUpdate(Session.get("room"));
    }
   // Meteor.subscribe("rooms");
    if(location.hash){
      changeRoom(location.hash.toLowerCase());
    }
    else{
      changeRoom("#main");
    }
    
    heartBeat(false);
    Meteor.setInterval(function() {heartBeat(false);},30000);
    setServerTime();
    Meteor.setInterval(function() {setServerTime();},900000);
  });

  function changeRoom(room){
      if(room != Session.get("room")){
        if(room.charAt(0) != "#"){
        room = "#"+room;
        }
      Meteor.subscribe("basicInfo",room);
      Meteor.subscribe("messages",room);
      Meteor.subscribe("typers",room);
      Meteor.subscribe("roomers",room);
      Session.set("room",room);
      document.getElementById("room").value = room;
      document.title = room+' - LocalChattr - '+ Session.get("LC_APP_NAME");
      location.hash = room; 
      if(Meteor.user()){
        roomersUpdate(Session.get("room"));
      }
    }
  }

  window.onfocus = function() {
      focused = true;
      played = false;
  };

  window.onblur = function() {
      focused = false;
  };

  function play(){
    if(played == false){
       document.getElementById('alert').play();
       played = true;
    }
  }

  function heartBeat(report){
    if(Meteor.user() && !firstRun){
      roomersUpdate(Session.get("room"));
      stored_count = Messages.find({room: Session.get("room")}).count();
    }

    if(report){
      console.log("heartbeat");
    }
  }
 if (("onhashchange" in window)) {
         window.onhashchange = function () {
            changeRoom(location.hash.toLowerCase());
         }
    }

  Template.leaderboard.messages = function () {
    fullnumber = Messages.find({room: Session.get("room")}).count();
    if(fullnumber > 0){
      if(firstRun){
		  document.title = Session.get("room")+' - LocalChattr - '+ Session.get("LC_APP_NAME");
        if(fullnumber < 6){
          toskip = 0;
        }
        else{
          toskip = fullnumber-5;
        }
        startingtime = Messages.findOne({room: Session.get("room")}, {sort: {time: 1}, skip: toskip}).time;
        firstRun = false;
      }
      messages = Messages.find({time: {$gte: startingtime}, room: Session.get("room")},{sort: {time: 1}});

      if(fullnumber > stored_count){
        scrollme += 1;
      }
      if(stored_count > 0 && fullnumber > (stored_count) && !focused && !firstRun){
        stored_count = fullnumber;
         if(playfix == true){
            play();
            window.alert("New message from " + Messages.findOne({room: Session.get("room")}, {sort: {time: -1}}).name);
          }
          else{
            playfix = true;
          }
      }
      else if (stored_count == 0 && !firstRun){
        stored_count = fullnumber;
      }
      return messages;
    }
  };
  
   Template.title.name = Template.leaderboard.title = function () {
     return 'LocalChattr - '+ Session.get("LC_APP_NAME");
  };

   Template.extra.text = function () {
     return Session.get("LC_APP_EXTRA");
    
  };

  Template.footer.version = function () {
     return Session.get("LC_APP_VERSION");
    
  };

  Template.xmpp.server = function () {
     return window.location.hostname;
  };

  Template.xmpp.account_name = function () {
     return Meteor.user().emails[0].address.replace("@","#");
  };

  Template.xmpp.password = function () {
     return hex_md5("LocalChattr"+Meteor.user().emails[0].address.replace("@","#")).substring(0,6);
  };

  Template.leaderboard.typers = function () {
    return Typers.find({room: Session.get("room")}, {sort: {time: -1}, limit: 5});
  };

  Template.leaderboard.roomers = function () {
    return Roomers.find({room: Session.get("room"), time: {$gte: (getCurrentTime()-(1*65*1000))}}, {sort: {time: -1}});
  };

  Template.leaderboard.typerText = function () {
    count = Typers.find({room: Session.get("room")}).count();
    if(count == 0){
      return false;
    }
    else if(count > 1){
      return "are currently typing...";
    }
    else{
      return "is currently typing..."
    }
  };

  Template.login.gravatar_hash = Template.message.gravatar_hash = Template.typer.gravatar_hash = Template.roomer.gravatar_hash = function () {
    if(Meteor.user() && Meteor.user().emails[0].address){
      email = Meteor.user().emails[0].address;
      return gravatar_hash(email);
    }
  };

  Template.login.my_name = Template.message.my_name = Template.typer.my_name = Template.roomer.my_name = function () {
    if(Meteor.user() && Meteor.user().emails[0].address){
      return Meteor.user().emails[0].address;
    }
  };

  function fixScroll(){
    if(toScroll == true && document.getElementById("leaderboard").scrollTop != document.getElementById("leaderboard").scrollHeight){
      document.getElementById("leaderboard").scrollTop = document.getElementById("leaderboard").scrollHeight;
    }
  }

  Template.leaderboard.preserve(['#leaderboard']);
  Template.leaderboard.preserve(['#roomers']);
  Template.leaderboard.preserve(['#typing']);
  Template.leaderboard.rendered = function() {
    if(scrollme > 0 || firstRun){
      fixScroll();
      scrollme += 1;
    }
    if(scrollme > 1){
      scrollme = 0;
    }
    if(location.hash != Session.get("room")){
      changeRoom(location.hash.toLowerCase());
    }
  };
  
  Template.leaderboard.events({
    'blur input#room': function () {
      roomdoc = document.getElementById("room").value.trim().toLowerCase();
      if(roomdoc && roomdoc != "#"){
        changeRoom(roomdoc);
      }
      else{
        roomdoc = "#main";
        changeRoom(roomdoc);
      }
      
    },
    'keypress input#room': function (evt) {
      if (evt.which === 13) {
        roomdoc = document.getElementById("room").value.trim().toLowerCase();
        if(roomdoc && roomdoc != "#"){
          changeRoom(roomdoc);
        }
        else{
          roomdoc = "#main";
          changeRoom(roomdoc);
        }
      }
    },

    'click input#scroller': function () {  
      if(toScroll === true){
        toScroll = false;
        document.getElementById("scroller").value = "Turn On Auto-Scroll";
        document.getElementById('alert').play();
      }
      else{
        toScroll = true;
        document.getElementById("scroller").value = "Turn Off Auto-Scroll";
        document.getElementById('alert').play();
      }
    }
  });

Template.login.events({
    'click p#jabber': function () {
      if($("#jabber").html() == "Show XMPP Connection Info"){
        $("#jabber_info").fadeIn(400, function() {
          $("#jabber").html("Hide XMPP Connection Info");
        });
      }
      else{
       $("#jabber_info").fadeOut(400, function() {
          $("#jabber").html("Show XMPP Connection Info");
        });          
      }
    }
  });

  Template.details.events({
    'click input#sub': function () {
      var text = processText(document.getElementById("text").value);
      var edit = document.getElementById("edit").value;
      if(text){
         if(edit != "false"){
            Messages.update(edit,{$set: {text: text, extratext: "(Edited)", humanTime: getHumanTime(), timeAgo: "just now"}});
        }
        else{
          Messages.insert({name: Meteor.user().emails[0].address, text: text.trim(), time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: Session.get("room")});

        }
      }
      typer = Typers.findOne({userid: Meteor.user()._id, room: Session.get("room")});
      if(typer){
        typerid = typer._id;
        Typers.remove(typerid);
      }
      scrollme += 1;
      heartBeat(false);
        
      document.getElementById("text").value = "";
      document.getElementById("edit").value = "false";
      
    },

    'keypress textarea#text': function (evt) {
      if (evt.which === 13) {
        var text = processText(document.getElementById("text").value);
        var edit = document.getElementById("edit").value;
        if(text){
          if(edit != "false"){
              Messages.update(edit,{$set: {text: text, extratext: "(Edited)", humanTime: getHumanTime(), timeAgo: "just now"}});
          }
          else{
            Messages.insert({name: Meteor.user().emails[0].address, text: text.trim(), time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: Session.get("room")});
          }
          
        }
        typer = Typers.findOne({userid: Meteor.user()._id, room: Session.get("room")});
        if(typer){
          typerid = typer._id;
          Typers.remove(typerid);
        }
        scrollme += 1;
        heartBeat(false);  

        document.getElementById("text").value = "";
        document.getElementById("edit").value = "false";
        return false;
      }
      else{
        
        if(Typers.find({userid: Meteor.user()._id, room: Session.get("room")}).count() == 0){
          Typers.insert({userid: Meteor.user()._id, name: Meteor.user().emails[0].address, time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: Session.get("room")});
        }
        else{
          typer = Typers.findOne({userid: Meteor.user()._id, room: Session.get("room")});
          if(typer){
            typerid = typer._id;
            Typers.update(typerid, {$set: {time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now"}});
          }
        }
      }
    },
    'keyup textarea#text': function (evt) {    
      if(evt.which === 38){
        var text = Messages.findOne({room: Session.get("room")}, {sort: {time: -1}});
        if(text.name == Meteor.user().emails[0].address){
          document.getElementById("text").value = text.text.trim();
          document.getElementById("edit").value = text._id;
        }
      }
    },
    'blur textarea#text': function () {   
      typer = Typers.findOne({userid: Meteor.user()._id, room: Session.get("room")});
      if(typer){
        typerid = typer._id;
        Typers.remove(typerid);
      }
    }
    
  });



}

// On server startup, create some Messages if the database is empty.
  if (Meteor.isServer) {
    function getCurrentTime(){
      return new Date().getTime();
    }

    function getHumanTime(){
      return new Date().toISOString();
    }

    Meteor.publish("basicInfo", function() {
    return Meteor.users.find({_id: this.userId}, {fields: {profile: 1, emails: 1, 'services.facebook.email': 1, 'services.github.email': 1, 'services.google.email': 1}});
  });
  Meteor.publish("messages", function(room) {
    if(Rooms.find({room: room}).count() == 0){
        Rooms.insert({room: room, time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now"});
    }
    else{
      Rooms.update({room: room}, {$set: {time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now"}});
    }
    return Messages.find({room: room});
  });
  Meteor.publish("typers", function(room) {
    return Typers.find({room: room});
  });
  Meteor.publish("roomers", function(room) {
    return Roomers.find({room: room});
  });
  Meteor.publish("rooms", function() {
    return Rooms.find();
  });

  Messages.allow({
    insert: function (userId, doc) {  
      return (userId && doc.text.length < 700);
    },
    update: function (userId, doc, fields, modifier) {
      if(_.contains(fields, 'text') || _.contains(fields, 'name') || _.contains(fields, 'image')){
        if(userId && Meteor.user() && Meteor.user().profile){
          return (Messages.findOne(doc._id).name == doc.name && doc.name == Meteor.user().emails[0].address && Messages.findOne(doc._id).name == Meteor.user().emails[0].address);
        }
        else{
          return false;
        }
      }
      else if(_.contains(fields, 'room')){
        return false;
      }
      else{
        return (userId);
      }
   
    },
    remove: function (userId, doc) {
      return false;
    }
  });

  Typers.allow({
    insert: function (userId, doc) {  
      return (userId == doc.userid);
    },
    update: function (userId, doc, fields, modifier) {
      return (userId == doc.userid);
    },
    remove: function (userId, doc) {
      return (userId == doc.userid);
    }
  });

  Roomers.allow({
    insert: function (userId, doc) {  
      return (userId == doc.userid);
    },
    update: function (userId, doc, fields, modifier) {
      return (userId == doc.userid);
    },
    remove: function (userId, doc) {
      return (userId == doc.userid);
    }
  });

  Rooms.allow({
    insert: function (userId, doc) {  
      return true;
    },
    update: function (userId, doc, fields, modifier) {
      return false;
    }
  });

  Meteor.users.allow({
    update: function (userId, doc, fields, modifier) {
      return (_.contains(fields, 'profile'));
    }
  });

  Meteor.methods({
    getServerTime: function () {
      var _time = (new Date).getTime();
      return _time;
    },
    LC_APP_NAME: function(){
      return process.env.LC_APP_NAME;
    },
    LC_APP_EXTRA: function(){
      return process.env.LC_APP_EXTRA;
    },
    LC_APP_ADMIN: function(){
      return process.env.LC_APP_ADMIN;
    },
    LC_APP_VERSION: function(){
      return process.env.LC_APP_VERSION;
    },
   roomersUpdate: function(room){
      if(Meteor.user()){
        roomers_count = 0;
        roomers_count = Roomers.find({userid: Meteor.user()._id, room: room}).count();
        if(roomers_count > 1){
          Roomers.remove({room: room, userid: Meteor.user()._id});
          Roomers.insert({userid: Meteor.user()._id, name: Meteor.user().emails[0].address, time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: room});
        }
        else if(roomers_count == 1){
          Roomers.update({room: room}, {$set: {time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now"}});
        }
        else if(roomers_count == 0){
           Roomers.insert({userid: Meteor.user()._id, name: Meteor.user().emails[0].address, time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: room});
        }
      }
      return roomers_count;
    }
  });
  Accounts.validateNewUser(function (user) {
    var email = getEmail(user);
    if(Meteor.users.findOne({'email': {$regex:email,$options:'i'}})){
      throw new Meteor.Error(403, "Email address already registered");
      return false;
    }
    else{
      return true;
    }
  });
  
  Accounts.onCreateUser(function(options, user) {
    console.log("User "+user.emails[0].address+" created");
    if (options.profile){
      user.profile = options.profile;
    }
    user.email = user.emails[0].address;
    user.name = user.emails[0].address;
    return user;
  });

  function monitor(){
  //console.log("");
   //console.log("Short Mainentance Running");
    rooms_to_update = {};
    recent_messages = Messages.find({time: {$gte: (getCurrentTime()-(300000))}},{sort: {time: 1}}).fetch();
    if(recent_messages.length > 0){
      for (var i = recent_messages.length - 1; i >= 0; i--) {
        message_id = recent_messages[i]._id;
        message_humtime =  recent_messages[i].humanTime;
        message_time =  recent_messages[i].time;
        message_room = recent_messages[i].room;
        Messages.update(message_id,{$set: {timeAgo: humane_date(message_humtime)}});
        rooms_to_update[i] = {};
        rooms_to_update[i].room = message_room;
        rooms_to_update[i].time = message_time;
        rooms_to_update[i].humanTime = recent_messages[i].humanTime;
      };
    }
    if(rooms_to_update.length > 0){
      for (var i = rooms_to_update.length - 1; i >= 0; i--) {
        Rooms.update({room: rooms_to_update[i].room}, {$set: {time: rooms_to_update[i].time, humanTime: rooms_to_update[i].humanTime, timeAgo: humane_date(rooms_to_update[i].humanTime)}});
      };
    }
    //console.log("Short Maintenance Complete");
    //console.log("");
  }
  function maintenance(){
    //console.log("");
    //console.log("Long Mainentance Running");
    rooms_to_update = {};
    recent_messages = Messages.find({time: {$gte: (getCurrentTime()-(86400000))}},{sort: {time: 1}}).fetch();
    if(recent_messages.length > 0){
      for (var i = recent_messages.length - 1; i >= 0; i--) {
        message_id = recent_messages[i]._id;
        message_humtime =  recent_messages[i].humanTime;
        message_time =  recent_messages[i].time;
        message_room = recent_messages[i].room;
        Messages.update(message_id,{$set: {timeAgo: humane_date(message_humtime)}});
        rooms_to_update[i] = {};
        rooms_to_update[i].room = message_room;
        rooms_to_update[i].time = message_time;
        rooms_to_update[i].humanTime = recent_messages[i].humanTime;
      };
      if(recent_messages.length > 0){
        console.log(recent_messages.length+" Messages Processed");
      }
    }
    if(rooms_to_update.length > 0){
      for (var i = rooms_to_update.length - 1; i >= 0; i--) {
        Rooms.update({room: rooms_to_update[i].room}, {$set: {time: rooms_to_update[i].time, humanTime: rooms_to_update[i].humanTime, timeAgo: humane_date(rooms_to_update[i].humanTime)}});
      };
      if(rooms_to_update.length > 0){
        console.log(rooms_to_update.length+" Rooms Processed");
      }
    }
    Typers.remove({time: {$lt: (getCurrentTime()-(600000))}});
    //console.log("Old Typers Removed");
    Roomers.remove({time: {$lt: (getCurrentTime()-(600000))}});
    //console.log("Old Roomer Removed");
    rooms_to_remove = Rooms.find({time: {$lt: (getCurrentTime()-(86400000))}}).fetch();
    if(rooms_to_remove.length > 0){
      for (var i = rooms_to_remove.length - 1; i >= 0; i--) {
            roomid = rooms_to_remove[i].room;
            Messages.remove({room: roomid});
            Typers.remove({room: roomid});
            Roomers.remove({room: roomid});
            Rooms.remove({room: roomid});
      }
      if(rooms_to_remove.length > 0){
        console.log(rooms_to_remove.length+" Old Rooms Removed");
      }
    }
    Messages.remove({room: "#main", time: {$lt: (getCurrentTime()-(86400000))}});
    //console.log("Old #main Messages Removed");
    //console.log("Long Maintenance Complete");
    //console.log("");
  }
  Meteor.startup(function () {
    // Messages.remove({});
    // Meteor.users.remove({});
    // Roomers.remove({});
    // Typers.remove({});
    maintenance();
    Meteor.setInterval(maintenance,570000);
    Meteor.setInterval(monitor,60000);
    if (Messages.find({room: "#main"}).count() === 0) {
        Messages.insert({name: process.env.LC_APP_ADMIN, text: process.env.LC_APP_WELCOME, time: getCurrentTime(), humanTime: getHumanTime(), timeAgo: "just now", room: "#main"});
    }
  });
}


var hexcase=0;function hex_md5(a){return rstr2hex(rstr_md5(str2rstr_utf8(a)))}function hex_hmac_md5(a,b){return rstr2hex(rstr_hmac_md5(str2rstr_utf8(a),str2rstr_utf8(b)))}function md5_vm_test(){return hex_md5("abc").toLowerCase()=="900150983cd24fb0d6963f7d28e17f72"}function rstr_md5(a){return binl2rstr(binl_md5(rstr2binl(a),a.length*8))}function rstr_hmac_md5(c,f){var e=rstr2binl(c);if(e.length>16){e=binl_md5(e,c.length*8)}var a=Array(16),d=Array(16);for(var b=0;b<16;b++){a[b]=e[b]^909522486;d[b]=e[b]^1549556828}var g=binl_md5(a.concat(rstr2binl(f)),512+f.length*8);return binl2rstr(binl_md5(d.concat(g),512+128))}function rstr2hex(c){try{hexcase}catch(g){hexcase=0}var f=hexcase?"0123456789ABCDEF":"0123456789abcdef";var b="";var a;for(var d=0;d<c.length;d++){a=c.charCodeAt(d);b+=f.charAt((a>>>4)&15)+f.charAt(a&15)}return b}function str2rstr_utf8(c){var b="";var d=-1;var a,e;while(++d<c.length){a=c.charCodeAt(d);e=d+1<c.length?c.charCodeAt(d+1):0;if(55296<=a&&a<=56319&&56320<=e&&e<=57343){a=65536+((a&1023)<<10)+(e&1023);d++}if(a<=127){b+=String.fromCharCode(a)}else{if(a<=2047){b+=String.fromCharCode(192|((a>>>6)&31),128|(a&63))}else{if(a<=65535){b+=String.fromCharCode(224|((a>>>12)&15),128|((a>>>6)&63),128|(a&63))}else{if(a<=2097151){b+=String.fromCharCode(240|((a>>>18)&7),128|((a>>>12)&63),128|((a>>>6)&63),128|(a&63))}}}}}return b}function rstr2binl(b){var a=Array(b.length>>2);for(var c=0;c<a.length;c++){a[c]=0}for(var c=0;c<b.length*8;c+=8){a[c>>5]|=(b.charCodeAt(c/8)&255)<<(c%32)}return a}function binl2rstr(b){var a="";for(var c=0;c<b.length*32;c+=8){a+=String.fromCharCode((b[c>>5]>>>(c%32))&255)}return a}function binl_md5(p,k){p[k>>5]|=128<<((k)%32);p[(((k+64)>>>9)<<4)+14]=k;var o=1732584193;var n=-271733879;var m=-1732584194;var l=271733878;for(var g=0;g<p.length;g+=16){var j=o;var h=n;var f=m;var e=l;o=md5_ff(o,n,m,l,p[g+0],7,-680876936);l=md5_ff(l,o,n,m,p[g+1],12,-389564586);m=md5_ff(m,l,o,n,p[g+2],17,606105819);n=md5_ff(n,m,l,o,p[g+3],22,-1044525330);o=md5_ff(o,n,m,l,p[g+4],7,-176418897);l=md5_ff(l,o,n,m,p[g+5],12,1200080426);m=md5_ff(m,l,o,n,p[g+6],17,-1473231341);n=md5_ff(n,m,l,o,p[g+7],22,-45705983);o=md5_ff(o,n,m,l,p[g+8],7,1770035416);l=md5_ff(l,o,n,m,p[g+9],12,-1958414417);m=md5_ff(m,l,o,n,p[g+10],17,-42063);n=md5_ff(n,m,l,o,p[g+11],22,-1990404162);o=md5_ff(o,n,m,l,p[g+12],7,1804603682);l=md5_ff(l,o,n,m,p[g+13],12,-40341101);m=md5_ff(m,l,o,n,p[g+14],17,-1502002290);n=md5_ff(n,m,l,o,p[g+15],22,1236535329);o=md5_gg(o,n,m,l,p[g+1],5,-165796510);l=md5_gg(l,o,n,m,p[g+6],9,-1069501632);m=md5_gg(m,l,o,n,p[g+11],14,643717713);n=md5_gg(n,m,l,o,p[g+0],20,-373897302);o=md5_gg(o,n,m,l,p[g+5],5,-701558691);l=md5_gg(l,o,n,m,p[g+10],9,38016083);m=md5_gg(m,l,o,n,p[g+15],14,-660478335);n=md5_gg(n,m,l,o,p[g+4],20,-405537848);o=md5_gg(o,n,m,l,p[g+9],5,568446438);l=md5_gg(l,o,n,m,p[g+14],9,-1019803690);m=md5_gg(m,l,o,n,p[g+3],14,-187363961);n=md5_gg(n,m,l,o,p[g+8],20,1163531501);o=md5_gg(o,n,m,l,p[g+13],5,-1444681467);l=md5_gg(l,o,n,m,p[g+2],9,-51403784);m=md5_gg(m,l,o,n,p[g+7],14,1735328473);n=md5_gg(n,m,l,o,p[g+12],20,-1926607734);o=md5_hh(o,n,m,l,p[g+5],4,-378558);l=md5_hh(l,o,n,m,p[g+8],11,-2022574463);m=md5_hh(m,l,o,n,p[g+11],16,1839030562);n=md5_hh(n,m,l,o,p[g+14],23,-35309556);o=md5_hh(o,n,m,l,p[g+1],4,-1530992060);l=md5_hh(l,o,n,m,p[g+4],11,1272893353);m=md5_hh(m,l,o,n,p[g+7],16,-155497632);n=md5_hh(n,m,l,o,p[g+10],23,-1094730640);o=md5_hh(o,n,m,l,p[g+13],4,681279174);l=md5_hh(l,o,n,m,p[g+0],11,-358537222);m=md5_hh(m,l,o,n,p[g+3],16,-722521979);n=md5_hh(n,m,l,o,p[g+6],23,76029189);o=md5_hh(o,n,m,l,p[g+9],4,-640364487);l=md5_hh(l,o,n,m,p[g+12],11,-421815835);m=md5_hh(m,l,o,n,p[g+15],16,530742520);n=md5_hh(n,m,l,o,p[g+2],23,-995338651);o=md5_ii(o,n,m,l,p[g+0],6,-198630844);l=md5_ii(l,o,n,m,p[g+7],10,1126891415);m=md5_ii(m,l,o,n,p[g+14],15,-1416354905);n=md5_ii(n,m,l,o,p[g+5],21,-57434055);o=md5_ii(o,n,m,l,p[g+12],6,1700485571);l=md5_ii(l,o,n,m,p[g+3],10,-1894986606);m=md5_ii(m,l,o,n,p[g+10],15,-1051523);n=md5_ii(n,m,l,o,p[g+1],21,-2054922799);o=md5_ii(o,n,m,l,p[g+8],6,1873313359);l=md5_ii(l,o,n,m,p[g+15],10,-30611744);m=md5_ii(m,l,o,n,p[g+6],15,-1560198380);n=md5_ii(n,m,l,o,p[g+13],21,1309151649);o=md5_ii(o,n,m,l,p[g+4],6,-145523070);l=md5_ii(l,o,n,m,p[g+11],10,-1120210379);m=md5_ii(m,l,o,n,p[g+2],15,718787259);n=md5_ii(n,m,l,o,p[g+9],21,-343485551);o=safe_add(o,j);n=safe_add(n,h);m=safe_add(m,f);l=safe_add(l,e)}return Array(o,n,m,l)}function md5_cmn(h,e,d,c,g,f){return safe_add(bit_rol(safe_add(safe_add(e,h),safe_add(c,f)),g),d)}function md5_ff(g,f,k,j,e,i,h){return md5_cmn((f&k)|((~f)&j),g,f,e,i,h)}function md5_gg(g,f,k,j,e,i,h){return md5_cmn((f&j)|(k&(~j)),g,f,e,i,h)}function md5_hh(g,f,k,j,e,i,h){return md5_cmn(f^k^j,g,f,e,i,h)}function md5_ii(g,f,k,j,e,i,h){return md5_cmn(k^(f|(~j)),g,f,e,i,h)}function safe_add(a,d){var c=(a&65535)+(d&65535);var b=(a>>16)+(d>>16)+(c>>16);return(b<<16)|(c&65535)}function bit_rol(a,b){return(a<<b)|(a>>>(32-b))};

function humane_date(date_str){
  var time_formats = [
    [60, 'Just Now'],
    [90, '1 Minute'], // 60*1.5
    [3600, 'Minutes', 60], // 60*60, 60
    [5400, '1 Hour'], // 60*60*1.5
    [86400, 'Hours', 3600], // 60*60*24, 60*60
    [129600, '1 Day'], // 60*60*24*1.5
    [604800, 'Days', 86400], // 60*60*24*7, 60*60*24
    [907200, '1 Week'], // 60*60*24*7*1.5
    [2628000, 'Weeks', 604800], // 60*60*24*(365/12), 60*60*24*7
    [3942000, '1 Month'], // 60*60*24*(365/12)*1.5
    [31536000, 'Months', 2628000], // 60*60*24*365, 60*60*24*(365/12)
    [47304000, '1 Year'], // 60*60*24*365*1.5
    [3153600000, 'Years', 31536000], // 60*60*24*365*100, 60*60*24*365
    [4730400000, '1 Century'], // 60*60*24*365*100*1.5
  ];

  var time = ('' + date_str).replace(/-/g,"/").replace(/[TZ]/g," "),
    dt = new Date,
    seconds = ((dt - new Date(time) + (dt.getTimezoneOffset() * 60000)) / 1000),
    token = ' Ago',
    i = 0,
    format;

  if (seconds < 0) {
    seconds = Math.abs(seconds);
    token = '';
  }

  while (format = time_formats[i++]) {
    if (seconds < format[0]) {
      if (format.length == 2) {
        return format[1] + (i > 1 ? token : ''); // Conditional so we don't return Just Now Ago
      } else {
        return Math.round(seconds / format[2]) + ' ' + format[1] + (i > 1 ? token : '');
      }
    }
  }

  // overflow for centuries
  if(seconds > 4730400000)
    return Math.round(seconds / 4730400000) + ' Centuries' + token;

  return date_str;
};

})();
